
/*https://www.youtube.com/watch?v=gFVz3t8bx-w
    
*/

#include <mega8.h>

#include <delay.h>


unsigned char digit_out[5], //   (  0  4 a)
                   cur_dig; // .  () 
unsigned int f=400,    //  
             yarkost ; //   
//             z=1000;   // ms    

                    
static flash unsigned char digits[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
  





// ---------------- Timer 2 overflow interrupt service routine -----------------------------
//
//  -    (62500  / 256) = 244 
//       (244 / 4) = 61 
//
interrupt [TIM2_OVF] void timer2_ovf_isr(void){

     PORTC&=0b00000000;                  //   ( - off)
 
     PORTD=~digits[digit_out[cur_dig]];
 
     PORTC |= (1<<cur_dig);            //    (  - on)
     
         cur_dig++; if (cur_dig >= 5) {
        cur_dig = 0; 
       OCR2 = yarkost;
    } 
   
}// ----------------------------------------------------------------------------------------

// ------------------ Timer2 output compare interrupt service routine ----------------------

interrupt [TIM2_COMP] void timer2_comp_isr(void){

    PORTC&=0b00000000; 
 //    PORTD=0b11111111;
	
}// ----------------------------------------------------------------------------------------


// ----------------------------------------------------------------------------------------

void view_flasher_13(void) {
     int i;
   
   for (i =0; i<9;++i){
      

     
   yarkost+=27; if (yarkost > 250) yarkost = 0; 

    digit_out[0] = 15;
    digit_out[1] = 15;
    digit_out[2] = 15;
    digit_out[3] = 15;
    digit_out[4] = 15; 
    
        delay_ms(f);
     } 
      
  }

// ----------------------------------------------------------------------------------------

// ----------------------------------------------------------------------------------------

void view_flasher_14(void) {
     int i;
   
   for (i =0; i<9;++i){
      

     
   yarkost-=27; if (yarkost < 0) yarkost = 250; 

    digit_out[0] = 15;
    digit_out[1] = 15;
    digit_out[2] = 15;
    digit_out[3] = 15;
    digit_out[4] = 15; 
    
        delay_ms(f);
     } 
      
  }

// ----------------------------------------------------------------------------------------


//===================================== main ==============================================
  
// 
void main(void){
          
   digit_out[0]=0;   //  
   digit_out[1]=0;
   digit_out[2]=0;
   digit_out[3]=0;
   digit_out[4]=0;
   
 
// 
PORTB=0b00000000; 
 DDRB=0b00000000; 
PORTC=0b00000000;   //  4    1
 DDRC=0b00011111;   //  4    
PORTD=0b00000000;  // D      0
 DDRD=0b00001111;  // D    
               
 
 
 
ACSR=0x80;



 
 
 
TCCR2=0x04;
TIMSK=0b11000000;
//              0b11000001
//                ||   | |
//                ||   | Timer0
//                ||   Timer1
//                |Timer2
//
#asm("sei")   //   
   
// --------------------------------   ------------------------------------------
 while (1) { 
  
     
  view_flasher_13(); 
   view_flasher_14(); 
  
 }; // -----------------------------   (end) ------------------------------------

} // =================================== end main ==========================================

//
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- The End -=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//









